    {% extends 'base.html' %} 

    {% block title %}Detail{% endblock %}

    {% block content  %}

    <div class="row mt-2" > 
        <div class="col-8 mx-auto">
            <a href="{% url 'blog_list' %}" class="btn btn-secondary">Back</a>
            {% if messages %}
                <div class="mt-2">
                    {% for message in messages %}
                        <p style="color:green;">{{ message }}</p>
                    {% endfor %}
                </div>      
            {% endif %} 
                <p style="font-size:28px;" class="mt-2" id="postTitleId">{{ post.title }}</p>
                <p id="postUserDetailId"><span class="text-muted">by </span> <b>{{post.user.username}}</b> <span class="text-muted">on {{ post.created }} </span></p> 
                <div id="postContentId">{{ post.content }}


                </div> 
                
                <p> 
                {% for img in post.post_image.all %} 
                    <img src="{{ img.image.url }}" style="width: 40%; display: inline;"> 
                {% endfor %} 
                </p>
                <hr> 

                <div>
                    {% if request.user.is_authenticated %} 
                        {% if request.user == post.user %}
                            <a id="blogUpdateId" href="{% url 'blog_update' post.id %}" class="btn btn-primary active">Update</a>
                            <a id="postDeleteId" href="{% url 'blog_delete' post.id %}" class="btn btn-danger active">Delete</a>
                            <hr>
                        {% endif %}
                    {% endif %}

                </div>
                <h3>Comments</h3>
                {% if request.user.is_authenticated %}
                    <form method="POST" id="commentForm">
                        {% csrf_token %}

                        <div class="mb-3"> 
                            <textarea  class="form-control" id="comment" rows="5" name="content" placeholder="Comment..."></textarea>
                            <div id="comment" class="form-text"></div>
                        </div>
                        <input type="submit" value="Comment" class="btn btn-success mb-3">
                    </form>
                {% endif %}
                <div id="commentsId">
                    {% if post.post_comment %} 
                            {% for comment in post.post_comment.all %}
                                <p><b>{{ comment.user.username }}</b> on <span class="text-muted">{{ comment.date_time }}</span> <br>{{ comment.content }}</p>
                            {% endfor %}  
                    {% endif %} 
                </div>
            </div>
        </div>

        <div class="modal" tabindex="-1" role="dialog" id="post-update-modal">
            <div class="modal-dialog" role="document">
            <div class="modal-content">
                
            </div>
            </div>
        </div>

        <script>

            $('#post-update-modal').on('click', '.close', function(){
                $(this).closest('div.modal').hide();
            })

            $('body').on('click', '#postDeleteId', function(e){
                e.preventDefault();
                const href = $(this).attr('href');

                if(confirm("Do you really want to delete the post?")){
                    $.ajax({
                        url: href,
                        method: 'POST',
                        data: {
                                csrfmiddlewaretoken: "{{ csrf_token }}"
                            },
                        success: function(resp){ 
                            if(resp.status == 200){        
                               location.replace(location.origin + "{% url 'blog_list' %}");
                            }

                        },
                        error: function(err){
                            alert(err.message);
                        }
                    })
                }  
                
            })

            $('body').on('submit', '#postUpdateForm', function(e){
                e.preventDefault();
                let formData = new FormData(this); 

                const post_id = $(this).attr('data-pk');
                const updateUrl = "{% url 'blog_update' 11 %}".replace(11, post_id);

                $.ajax({
                    url: updateUrl,
                    method: "POST",
                    data: formData,
                    processData: false,
                    contentType:false,

                    success: function(resp){
                        console.log(resp)

                        if(resp.status == 200){ 
                            $("#postTitleId").text(resp.instance.title);
                            $("#postUserDetailId").html(`<span class="text-muted">by </span> <b>${resp.instance.user}</b> <span class="text-muted">on ${resp.instance.updated} </span>`)
                            // let contentText = "{{ 11|linebreaks }}".replace(11, resp.instance.content);
                             
                            $("#postContentId").empty().html(resp.instance.content);
                            $('.modal').hide();
                        }else{
                            for(let rr of resp.errors){ 
                                let el = $('#post-update-modal #'+rr[0]+'Error');
                                el.text(rr[1]);
                                el.css('display', 'block');
                                setTimeout(() => {
                                    el.css('display', 'none')
                                }, 1000);
                            }
                        }
                    },
                    error:function(err){
                        console.log(err);
                    }
                })

            })
            
    
            $('#blogUpdateId').on('click', function(e){
                e.preventDefault();
                const href = $(this).attr("href"); 

                $.ajax({
                    url:href,
                    method: 'GET',

                    success: function(resp){    

                    if(resp.status == 200){
                        console.log(resp);
                        let r = `
                        <div class="modal-header">
                            <h5 class="modal-title">Update Post</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>

                        <form method="post" id="postUpdateForm" data-pk="${resp.instance['id']}">
                            {% csrf_token %}

                            <div class="modal-body">
                                <div class="mb-3">
                                    <label for="title" class="form-label">Title</label>
                                    <input type="text" class="form-control" id="title"  name="title" value="${resp.instance['title']}" >  
                                    <div id="titleError" class="form-text" style="display:none;color:red;"></div>
                                </div>
                                <div class="mb-3">
                                    <label for="content" class="form-label">Content</label>
                                    <textarea class="form-control" id="content" rows="5"  name="content" > ${resp.instance['content']}</textarea>
                                    <div id="contentError" class="form-text" style="display:none;color:red;"></div>
                                </div>
                            </div>

                            <div class="modal-footer">  
                                <input type="submit" class="btn btn-success" value="Update">  
                            </div>
                        </form> `;  

                    $('#post-update-modal').show();
                    $('#post-update-modal .modal-content').empty().append(r);
                    
                }else{
                    alert(resp.errors);
                }                
                    },
                    error: function(err){
                        console.log(err);
                    }
                })
            })

        $('#commentForm').on('submit', function(e){
            e.preventDefault();
            let formData = new FormData(this);  
            const postId = "{{post.id}}";
            const commentUrl = "{% url 'blog_comment' 11 %}".replace(11, postId );

            // for(let v of formData.entries()){
            //     console.log(v[0], v[1])
            // }

            $.ajax({
                url: commentUrl,
                method:'POST',
                data: formData,
                processData:false,
                contentType: false,
                
                success: function(resp){
                    $('#commentForm')[0].reset();
                    console.log(resp);
                    if(resp.status == 200){
                        let instance = resp.instance;
                        console.log(instance)
                        let r = `<p><b>${instance.user}</b> on<span class="text-muted">${instance.date_time}</span> <br>${instance.content}</p>`;
                        $('#commentsId').append(r);
                    }else{
                        alert(resp.errors[0][1]);
                    }
                },
                error: function(err){
                    console.log(err);
                }
            })
        })

        </script>
    {% endblock %}